Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2587)
@@ -25,19 +25,19 @@
 
 namespace HeuristicLab.LinearRegression {
-  [ClassInfo(Name = "HeuristicLab.LinearRegression-3.2")]
-  [PluginFile(Filename = "HeuristicLab.LinearRegression-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "ALGLIB")]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.GP-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification.Classification-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification.TimeSeries-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
+  [Plugin("HeuristicLab.LinearRegression-3.2")]
+  [PluginFile("HeuristicLab.LinearRegression-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("ALGLIB")]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.GP-3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification-3.3")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification.Classification-3.3")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification.TimeSeries-3.3")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
   public class HeuristicLabLinearRegression : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 2587)
@@ -29,12 +29,12 @@
   /// Plugin class for HeuristicLab.Logging plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Logging-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Logging-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Charting-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Charting.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.Logging-3.2")]
+  [PluginFile("HeuristicLab.Logging-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Charting-3.2")]
+  [PluginDependency("HeuristicLab.Charting.Data-3.2")]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabLoggingPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabDockingMainFormTestApplication.cs	(revision 2587)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  [ClassInfo(Name = "DockingMainForm  Test", Description = "Test application for new mainform development.")]
+  [Application("DockingMainForm  Test", "Test application for new mainform development.")]
   public class HeuristicLabDockingMainFormTestApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMainFormTestPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.MainForm.Test {
-  [ClassInfo(Name = "HeuristicLab.MainForm.Test-3.2")]
-  [PluginFile(Filename = "HeuristicLab.MainForm.Test-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.MainForm.WindowsForms-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Common.Resources-3.2")]
+  [Plugin("HeuristicLab.MainForm.Test-3.2")]
+  [PluginFile("HeuristicLab.MainForm.Test-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms-3.2")]
+  [PluginDependency("HeuristicLab.Common.Resources-3.2")]
   public class HeuristicLabMainFormTestPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabMultipleDocumentMainFormTestApplication.cs	(revision 2587)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  [ClassInfo(Name = "MultipleDocumentMainForm Test", Description="Test application for new mainform development.")]
+  [Application("MultipleDocumentMainForm Test", "Test application for new mainform development.")]
   public class HeuristicLabMultipleDocumentMainFormTestApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2587)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  [ClassInfo(Name = "SingleDocumentMainForm Test", Description="Test application for new mainform development.")]
+  [Application("SingleDocumentMainForm Test", "Test application for new mainform development.")]
   public class HeuristicLabSingleDocumentMainFormTestApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/HeuristicLabMainFormWindowsFormsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/HeuristicLabMainFormWindowsFormsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/HeuristicLabMainFormWindowsFormsPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.MainForm.WindowsForms {
-  [ClassInfo(Name = "HeuristicLab.MainForm.WindowsForms-3.2")]
-  [PluginFile(Filename = "HeuristicLab.MainForm.WindowsForms-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [PluginFile(Filename = "WeifenLuo.WinFormsUI.Docking.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.MainForm-3.2")]
+  [Plugin("HeuristicLab.MainForm.WindowsForms-3.2")]
+  [PluginFile("HeuristicLab.MainForm.WindowsForms-3.2.dll", PluginFileType.Assembly)]
+  [PluginFile("WeifenLuo.WinFormsUI.Docking.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.MainForm-3.2")]
   public class HeuristicLabMainFormTestPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2587)
@@ -269,10 +269,8 @@
 
     #region create menu and toolbar
-    protected virtual void CreateGUI() {
-      DiscoveryService ds = new DiscoveryService();
-
-      object[] items = ds.GetInstances(userInterfaceItemType);
+    protected virtual void CreateGUI() {      
+
       IEnumerable<IMenuItem> toolStripMenuItems =
-        from mi in items
+        from mi in ApplicationManager.Manager.GetInstances(userInterfaceItemType)
         where mi is IMenuItem
         orderby ((IMenuItem)mi).Position
@@ -281,7 +279,6 @@
         AddToolStripMenuItem(menuItem);
 
-      items = ds.GetInstances(userInterfaceItemType);
       IEnumerable<IToolBarItem> toolStripButtonItems =
-        from bi in items
+        from bi in ApplicationManager.Manager.GetInstances(userInterfaceItemType)
         where bi is IToolBarItem
         orderby ((IToolBarItem)bi).Position
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs	(revision 2587)
@@ -26,6 +26,6 @@
 
 namespace HeuristicLab.Modeling.Database {
-  [ClassInfo(Name = "HeuristicLab.MainForm-3.2")]
-  [PluginFile(Filename = "HeuristicLab.MainForm-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.MainForm-3.2")]
+  [PluginFile("HeuristicLab.MainForm-3.2.dll", PluginFileType.Assembly)]
   public class HeuristicLabMainFormPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/MainFormManager.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/MainFormManager.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.MainForm/3.2/MainFormManager.cs	(revision 2587)
@@ -43,7 +43,6 @@
           MainFormManager.mainform = mainform;
 
-          DiscoveryService ds = new DiscoveryService();
           IEnumerable<Type> types =
-            from t in ds.GetTypes(typeof(IView))
+            from t in ApplicationManager.Manager.GetTypes(typeof(IView))
             where !t.IsAbstract && !t.IsInterface && !t.IsGenericType && ContentAttribute.HasContentAttribute(t)
             select t;
@@ -123,5 +122,5 @@
       if (!typeof(IView).IsAssignableFrom(viewType))
         throw new ArgumentException("View can not be created becaues given type " + viewType.ToString() + " is not of type IView.");
-      return (IView)Activator.CreateInstance(viewType,objectToView);
+      return (IView)Activator.CreateInstance(viewType, objectToView);
     }
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLabModelingDatabaseSQLServerCompactPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLabModelingDatabaseSQLServerCompactPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLabModelingDatabaseSQLServerCompactPlugin.cs	(revision 2587)
@@ -26,12 +26,12 @@
 
 namespace HeuristicLab.Modeling.Database.SQLServerCompact {
-  [ClassInfo(Name = "HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Modeling.Database.SQLServerCompact-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling.Database-3.2")]
-  [Dependency(Dependency = "HeuristicLab.SQLServerCompact-3.2")]  
+  [Plugin("HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
+  [PluginFile("HeuristicLab.Modeling.Database.SQLServerCompact-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Modeling.Database-3.2")]
+  [PluginDependency("HeuristicLab.SQLServerCompact-3.2")]  
   public class HeuristicLabModelingDatabaseSQLServerCompactPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database/3.2/HeuristicLabModelingDatabasePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database/3.2/HeuristicLabModelingDatabasePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling.Database/3.2/HeuristicLabModelingDatabasePlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Modeling.Database {
-  [ClassInfo(Name = "HeuristicLab.Modeling.Database-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Modeling.Database-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
+  [Plugin("HeuristicLab.Modeling.Database-3.2")]
+  [PluginFile("HeuristicLab.Modeling.Database-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
   public class HeuristicLabModelingDatabasePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2587)
@@ -26,11 +26,11 @@
 
 namespace HeuristicLab.Modeling {
-  [ClassInfo(Name = "HeuristicLab.Modeling-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Modeling-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "ALGLIB")]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
+  [Plugin("HeuristicLab.Modeling-3.2")]
+  [PluginFile("HeuristicLab.Modeling-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("ALGLIB")]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
   public class HeuristicLabModelingPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Metaprogramming/3.2/HeuristicLabOperatorsMetaprogrammingPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Metaprogramming/3.2/HeuristicLabOperatorsMetaprogrammingPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Metaprogramming/3.2/HeuristicLabOperatorsMetaprogrammingPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.Operators.Metaprogramming plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Operators.Metaprogramming-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Operators.Metaprogramming-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.Operators.Metaprogramming-3.2")]
+  [PluginFile("HeuristicLab.Operators.Metaprogramming-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabOperatorsMetaprogrammingPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Programmable/3.2/HeuristicLabOperatorsProgrammablePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Programmable/3.2/HeuristicLabOperatorsProgrammablePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Programmable/3.2/HeuristicLabOperatorsProgrammablePlugin.cs	(revision 2587)
@@ -26,9 +26,9 @@
 
 namespace HeuristicLab.Operators.Programmable {
-  [ClassInfo(Name = "HeuristicLab.Operators.Programmable-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Operators.Programmable-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.Operators.Programmable-3.2")]
+  [PluginFile("HeuristicLab.Operators.Programmable-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabOperatorsProgrammablePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Stopwatch/3.2/HeuristicLabOperatorsStopwatchPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Stopwatch/3.2/HeuristicLabOperatorsStopwatchPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators.Stopwatch/3.2/HeuristicLabOperatorsStopwatchPlugin.cs	(revision 2587)
@@ -26,9 +26,9 @@
 
 namespace HeuristicLab.Operators.Stopwatch {
-  [ClassInfo(Name = "HeuristicLab.Operators.Stopwatch-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Operators.Stopwatch-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.Operators.Stopwatch-3.2")]
+  [PluginFile("HeuristicLab.Operators.Stopwatch-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabOperatorsStopwatchPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.Operators plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Operators-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Operators-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Plugin("HeuristicLab.Operators-3.2")]
+  [PluginFile("HeuristicLab.Operators-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Constraints-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
   public class HeuristicLabOperatorsPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/AvailableOperatorsForm.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/AvailableOperatorsForm.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/AvailableOperatorsForm.cs	(revision 2587)
@@ -56,13 +56,10 @@
       builtinOperatorsTreeView.TreeViewNodeSorter = nodeSorter;
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      PluginInfo[] plugins = discoveryService.Plugins;
-      foreach(PluginInfo plugin in plugins) {
+      foreach(IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginItem = new TreeNode();
         pluginItem.Text = plugin.Name;
         pluginItem.Tag = plugin;
 
-        Type[] operators = discoveryService.GetTypes(typeof(IOperator), plugin);
-        foreach(Type type in operators) {
+        foreach(Type type in ApplicationManager.Manager.GetTypes(typeof(IOperator), plugin)) {
           if(!type.IsAbstract) {
             TreeNode operatorItem = new TreeNode();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLab.OptimizationFrontend-3.2.csproj
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLab.OptimizationFrontend-3.2.csproj	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLab.OptimizationFrontend-3.2.csproj	(revision 2587)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.OptimizationFrontend</RootNamespace>
     <AssemblyName>HeuristicLab.OptimizationFrontend-3.2</AssemblyName>
-    <TargetFrameworkVersion>v2.0</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <SignAssembly>true</SignAssembly>
@@ -70,4 +70,7 @@
   <ItemGroup>
     <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
     <Reference Include="System.Data" />
     <Reference Include="System.Drawing" />
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendApplication.cs	(revision 2587)
@@ -27,9 +27,9 @@
 
 namespace HeuristicLab.OptimizationFrontend {
-  [ClassInfo(Name = "HeuristicLab 3.2", Description="Next generation heuristic optimization environment.")]
+  [Application("HeuristicLab 3.2", "Next generation heuristic optimization environment.")]
   class HeuristicLabOptimizationFrontendApplication : ApplicationBase {
     public override void Run() {
       Form mainForm = new MainForm();
-      PluginManager.ControlManager = (IControlManager)mainForm;
+      ControlManager.RegisterManager((IControlManager)mainForm);
       Application.Run(mainForm);
     }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/HeuristicLabOptimizationFrontendPlugin.cs	(revision 2587)
@@ -27,7 +27,7 @@
 
 namespace HeuristicLab.OptimizationFrontend {
-  [ClassInfo(Name = "HeuristicLab.OptimizationFrontend-3.2")]
-  [PluginFile(Filename = "HeuristicLab.OptimizationFrontend-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.OptimizationFrontend-3.2")]
+  [PluginFile("HeuristicLab.OptimizationFrontend-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class HeuristicLabOptimizationFrontendPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/MainForm.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/MainForm.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.OptimizationFrontend/3.2/MainForm.cs	(revision 2587)
@@ -26,4 +26,5 @@
 using System.Drawing;
 using System.Text;
+using System.Linq;
 using System.Threading;
 using System.Windows.Forms;
@@ -58,12 +59,8 @@
       runningTasks = 0;
 
-      DiscoveryService discoveryService = new DiscoveryService();
-
       // discover creatable items
-      Type[] creatables = discoveryService.GetTypes(typeof(IEditable));
-      string[] names = new string[creatables.Length];
-      for (int i = 0; i < creatables.Length; i++)
-        names[i] = creatables[i].Name;
-      Array.Sort(names, creatables);
+      IEnumerable<Type> creatables = from x in ApplicationManager.Manager.GetTypes(typeof(IEditable))
+                                     orderby x.Name
+                                     select x;
       foreach (Type type in creatables) {
         if (!type.IsAbstract) {
@@ -84,6 +81,6 @@
 
     #region IControlManager Members
-    public void ShowControl(IControl control) {
-      if (InvokeRequired) Invoke((Action<IControl>)ShowControl, control);
+    public void ShowControl(object control) {
+      if (InvokeRequired) Invoke((Action<object>)ShowControl, control);
       else {
         if (control is IEditor) {
@@ -176,5 +173,5 @@
         else {
           editor.Filename = task.filename;
-          PluginManager.ControlManager.ShowControl(editor);
+          ControlManager.Manager.ShowControl(editor);
         }
         lock (locker) {
@@ -239,5 +236,5 @@
           MessageBox.Show("The selected item doesn't provide an editor.", "Editor Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
         } else {
-          PluginManager.ControlManager.ShowControl(editor);
+          ControlManager.Manager.ShowControl(editor);
           EnableDisableItems();
         }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Permutation/3.2/HeuristicLabPermutationPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Permutation/3.2/HeuristicLabPermutationPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Permutation/3.2/HeuristicLabPermutationPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.Permutation plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Permutation-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Permutation-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
+  [Plugin("HeuristicLab.Permutation-3.2")]
+  [PluginFile("HeuristicLab.Permutation-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
   public class HeuristicLabRandomPlugin : PluginBase {
   }
